package org.dromara.work.service.impl;

import org.dromara.common.core.utils.MapstructUtils;
import org.dromara.common.core.utils.StringUtils;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.common.mybatis.core.page.PageQuery;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import lombok.RequiredArgsConstructor;
import org.springframework.stereotype.Service;
import org.dromara.work.domain.bo.TpDesignQuotesBo;
import org.dromara.work.domain.vo.TpDesignQuotesVo;
import org.dromara.work.domain.TpDesignQuotes;
import org.dromara.work.mapper.TpDesignQuotesMapper;
import org.dromara.work.service.ITpDesignQuotesService;

import java.util.List;
import java.util.Map;
import java.util.Collection;

/**
 * 报价Service业务层处理
 *
 * @author Maosw
 * @date 2025-03-10
 */
@RequiredArgsConstructor
@Service
public class TpDesignQuotesServiceImpl implements ITpDesignQuotesService {

    private final TpDesignQuotesMapper baseMapper;

    /**
     * 查询报价
     *
     * @param id 主键
     * @return 报价
     */
    @Override
    public TpDesignQuotesVo queryById(Long id){
        return baseMapper.selectVoById(id);
    }

    /**
     * 分页查询报价列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 报价分页列表
     */
    @Override
    public TableDataInfo<TpDesignQuotesVo> queryPageList(TpDesignQuotesBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<TpDesignQuotes> lqw = buildQueryWrapper(bo);
        Page<TpDesignQuotesVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的报价列表
     *
     * @param bo 查询条件
     * @return 报价列表
     */
    @Override
    public List<TpDesignQuotesVo> queryList(TpDesignQuotesBo bo) {
        LambdaQueryWrapper<TpDesignQuotes> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<TpDesignQuotes> buildQueryWrapper(TpDesignQuotesBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<TpDesignQuotes> lqw = Wrappers.lambdaQuery();
        lqw.orderByAsc(TpDesignQuotes::getId);
        lqw.eq(bo.getSid() != null, TpDesignQuotes::getSid, bo.getSid());
        lqw.like(StringUtils.isNotBlank(bo.getSName()), TpDesignQuotes::getSName, bo.getSName());
        lqw.like(StringUtils.isNotBlank(bo.getProjectName()), TpDesignQuotes::getProjectName, bo.getProjectName());
        lqw.like(StringUtils.isNotBlank(bo.getClientName()), TpDesignQuotes::getClientName, bo.getClientName());
        lqw.between(params.get("beginCreateTime") != null && params.get("endCreateTime") != null,
            TpDesignQuotes::getCreateTime ,params.get("beginCreateTime"), params.get("endCreateTime"));
        lqw.eq(StringUtils.isNotBlank(bo.getRemark()), TpDesignQuotes::getRemark, bo.getRemark());
        lqw.eq(bo.getTenant() != null, TpDesignQuotes::getTenant, bo.getTenant());
        return lqw;
    }

    /**
     * 新增报价
     *
     * @param bo 报价
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(TpDesignQuotesBo bo) {
        TpDesignQuotes add = MapstructUtils.convert(bo, TpDesignQuotes.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改报价
     *
     * @param bo 报价
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(TpDesignQuotesBo bo) {
        TpDesignQuotes update = MapstructUtils.convert(bo, TpDesignQuotes.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(TpDesignQuotes entity){
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除报价信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteByIds(ids) > 0;
    }
}
